image: node:12
stages:
  - npm
  - test
  - build

npm:
  stage: npm
  script:
    - npm config set registry ${CI_NPM_REGISTRY}
    - npm install
  cache:
    paths:
      - node_modules/
  artifacts:
    expire_in: 1 days
    when: on_success
    paths:
      - node_modules/
  except:
    changes:
      - "k8s/*"

test:
  stage: test
  dependencies:
    - npm
  script:
    - npm run test
  except:
    changes:
      - "k8s/*"
  #except:  (demo only)
  #  - master



docker-build:
  image: docker:latest
  stage: build
  services:
    - docker:dind
  before_script:
    - echo $CI_BUILD_TOKEN | docker login -u "$CI_REGISTRY_USER"  --password-stdin $CI_REGISTRY
  script:
    - docker build --pull -t "$CI_REGISTRY_IMAGE" --build-arg "COMMIT_SHORT_SHA=$CI_COMMIT_SHORT_SHA" .
    - docker push "$CI_REGISTRY_IMAGE"
  except:
    changes:
      - "k8s/*"
